services:
  
  redis-server:
    image: redis:7.2.4
    environment: 
      - REDIS_ARGS="--save 30 1"
    volumes:
      - redis-data:/data
    ports:
      - 6379:6379

  ## API
  api:
    build:        
      context: ./api
      dockerfile: api.Dockerfile
    environment:
      - FRONT_URL=http://localhost:7070
      # to allow the front to connect to the API (CORS, Cross-Origin Resource Sharing)
    ports:
      - 6060:8080
      # query the API on http://localhost:6060/counter
    depends_on:
      redis-server:
        condition: service_started

  ## FrontEnd
  webapp:
    build:        
      context: ./web
      dockerfile: web.Dockerfile
    environment:
      - API_URL=http://localhost:6060
    ports:
      - 7070:8080
    # open the webapp http://localhost:7070/
    depends_on:
      api:
        condition: service_started

volumes:
  redis-data: